#include <windows.h>
#include <stdio.h>
#include "USBm.h"

#define CMD 0
#define DAT 1

HINSTANCE hDll = 0;

USBm_FindDevices_type		USBm_FindDevices;
USBm_NumberOfDevices_type	USBm_NumberOfDevices;
USBm_DeviceValid_type		USBm_DeviceValid;
USBm_DeviceVID_type			USBm_DeviceVID;
USBm_DevicePID_type			USBm_DevicePID;
USBm_DeviceDID_type			USBm_DeviceDID;
USBm_DeviceMfr_type			USBm_DeviceMfr;
USBm_DeviceProd_type		USBm_DeviceProd;
USBm_DeviceSer_type			USBm_DeviceSer;
USBm_InitPorts_type			USBm_InitPorts;
USBm_WriteA_type			USBm_WriteA;
USBm_WriteB_type			USBm_WriteB;
USBm_WriteABit_type			USBm_WriteABit;
USBm_WriteBBit_type			USBm_WriteBBit;
USBm_ReadA_type				USBm_ReadA;
USBm_ReadB_type				USBm_ReadB;
USBm_SetBit_type			USBm_SetBit;
USBm_ResetBit_type			USBm_ResetBit;
USBm_DirectionA_type		USBm_DirectionA;
USBm_DirectionB_type		USBm_DirectionB;
USBm_StrobeWrite_type		USBm_StrobeWrite;
USBm_StrobeRead_type		USBm_StrobeRead;
USBm_StrobeWrite2_type		USBm_StrobeWrite2;
USBm_StrobeRead2_type		USBm_StrobeRead2;
USBm_StrobeWrites_type		USBm_StrobeWrites;
USBm_StrobeReads_type		USBm_StrobeReads;
USBm_InitLCD_type			USBm_InitLCD;
USBm_LCDCmd_type			USBm_LCDCmd;
USBm_LCDData_type			USBm_LCDData;

void Write2Nibbles(BOOL, unsigned char);


int PASCAL WinMain(HINSTANCE hInstance,			// Application Instance Handle
					HINSTANCE hPrevInstance,	// always NULL
					LPSTR lpszCmdLine,			// Pointer to Command Line
					int nCmdShow)				// Show Window Option
{
	char textstr[300];
	unsigned char numdev;
	char *cp;

	hDll = LoadLibrary("USBm.dll");

	USBm_FindDevices =		(USBm_FindDevices_type)GetProcAddress(hDll, "USBm_FindDevices");
	USBm_NumberOfDevices =	(USBm_NumberOfDevices_type)GetProcAddress(hDll, "USBm_NumberOfDevices");
	USBm_DeviceValid =		(USBm_DeviceValid_type)GetProcAddress(hDll, "USBm_DeviceValid");
	USBm_DeviceVID =		(USBm_DeviceVID_type)GetProcAddress(hDll, "USBm_DeviceVID");
	USBm_DevicePID =		(USBm_DevicePID_type)GetProcAddress(hDll, "USBm_DevicePID");
	USBm_DeviceDID =		(USBm_DeviceDID_type)GetProcAddress(hDll, "USBm_DeviceDID");
	USBm_DeviceMfr =		(USBm_DeviceMfr_type)GetProcAddress(hDll, "USBm_DeviceMfr");
	USBm_DeviceProd =		(USBm_DeviceProd_type)GetProcAddress(hDll, "USBm_DeviceProd");
	USBm_DeviceSer =		(USBm_DeviceSer_type)GetProcAddress(hDll, "USBm_DeviceSer");
	USBm_InitPorts =		(USBm_InitPorts_type)GetProcAddress(hDll, "USBm_InitPorts");
	USBm_WriteA =			(USBm_WriteA_type)GetProcAddress(hDll, "USBm_WriteA");
	USBm_WriteB =			(USBm_WriteB_type)GetProcAddress(hDll, "USBm_WriteB");
	USBm_WriteABit =		(USBm_WriteABit_type)GetProcAddress(hDll, "USBm_WriteABit");
	USBm_WriteBBit =		(USBm_WriteBBit_type)GetProcAddress(hDll, "USBm_WriteBBit");
	USBm_ReadA =			(USBm_ReadA_type)GetProcAddress(hDll, "USBm_ReadA");
	USBm_ReadB =			(USBm_ReadB_type)GetProcAddress(hDll, "USBm_ReadB");
	USBm_SetBit =			(USBm_SetBit_type)GetProcAddress(hDll, "USBm_SetBit");
	USBm_ResetBit =			(USBm_ResetBit_type)GetProcAddress(hDll, "USBm_ResetBit");
	USBm_DirectionA =		(USBm_DirectionA_type)GetProcAddress(hDll, "USBm_DirectionA");
	USBm_DirectionB =		(USBm_DirectionB_type)GetProcAddress(hDll, "USBm_DirectionB");
	USBm_StrobeWrite =		(USBm_StrobeWrite_type)GetProcAddress(hDll, "USBm_StrobeWrite");
	USBm_StrobeRead =		(USBm_StrobeRead_type)GetProcAddress(hDll, "USBm_StrobeRead");
	USBm_StrobeWrite2 =		(USBm_StrobeWrite2_type)GetProcAddress(hDll, "USBm_StrobeWrite2");
	USBm_StrobeRead2 =		(USBm_StrobeRead2_type)GetProcAddress(hDll, "USBm_StrobeRead2");
	USBm_StrobeWrites =		(USBm_StrobeWrites_type)GetProcAddress(hDll, "USBm_StrobeWrites");
	USBm_StrobeReads =		(USBm_StrobeReads_type)GetProcAddress(hDll, "USBm_StrobeReads");
	USBm_InitLCD =			(USBm_InitLCD_type)GetProcAddress(hDll, "USBm_InitLCD");
	USBm_LCDCmd =			(USBm_LCDCmd_type)GetProcAddress(hDll, "USBm_LCDCmd");
	USBm_LCDData =			(USBm_LCDData_type)GetProcAddress(hDll, "USBm_LCDData");

	numdev = 0;

	// Discover the USBmicro devices
	USBm_FindDevices();

	// Number of discovered devices
	numdev = USBm_NumberOfDevices();

	if (numdev > 0)
	{
		USBm_InitPorts(0);
		USBm_DirectionA(0, 0xFF, 0xFF);

		USBm_StrobeWrite(0, 0x30, 0, 0x12);		// generic init nibble
		Sleep(5);
		USBm_StrobeWrite(0, 0x30, 0, 0x12);
		Sleep(1);
		USBm_StrobeWrite(0, 0x30, 0, 0x12);
		USBm_StrobeWrite(0, 0x20, 0, 0x12);		// set 4 bit I/F
		Write2Nibbles(CMD, 0x28);		// set 4 bit, 2 lines
		Write2Nibbles(CMD, 0x08);		// display off
		Write2Nibbles(CMD, 0x01);		// clear screen
		Sleep(1);
		Write2Nibbles(CMD, 0x06);		// cursor increment
		Write2Nibbles(CMD, 0x0C);		// display on, no cursor

		sprintf(textstr, "U421 single port");
		cp = textstr;
		while (*cp)
		{
			Write2Nibbles(DAT, *cp++);	// write string
		}

		Write2Nibbles(CMD, 0xC2);	// address 2nd line

		sprintf(textstr, "LCD control");
		cp = textstr;
		while (*cp)
		{
			Write2Nibbles(DAT, *cp++);	// write string
		}

	}

	FreeLibrary(hDll);
	return 0;
}

void Write2Nibbles(BOOL cmd, unsigned char data)
{
	unsigned char byte;

	byte = (data & 0xF0) | (cmd ? 1 : 0);	// data to A4~A7
	USBm_StrobeWrite(0, byte, 0, 0x12);		// RS = A0, RW = A1, E = A2

	byte = (data << 4) | (cmd ? 1 : 0);
	USBm_StrobeWrite(0, byte, 0, 0x12);
}